package metaobject;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;

public class MetaObjectManagerDialog extends JDialog {
	private static MetaObjectManagerDialog serviceManager;
	public MetaObjectManagerPanel metaObjectManagerPanel;
	
	public static MetaObjectManagerDialog showDailog(
		Container owner,
		String title,
		Class c) {
		if (serviceManager == null) {
			serviceManager = new MetaObjectManagerDialog(owner, title, c);
		}
		serviceManager.setVisible(true);
		return serviceManager;
	}

	private MetaObjectManagerDialog(
		final Container owner,
		String title,
		final Class c) {
		super(UIUtilities.getFrame(owner), title, false);
		this.addWindowListener(new WindowListener() {
			public void windowActivated(WindowEvent e) {
			}

			public void windowClosed(WindowEvent e) {
				MetaObjectManagerDialog.this.setVisible(false);
			}

			public void windowClosing(WindowEvent e) {
				MetaObjectManagerDialog.this.setVisible(false);
			}

			public void windowDeactivated(WindowEvent e) {
			}

			public void windowDeiconified(WindowEvent e) {
			}

			public void windowIconified(WindowEvent e) {
			}

			public void windowOpened(WindowEvent e) {
			}
		});

		JPanel panel = new JPanel(new BorderLayout());
		panel.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));

		this.metaObjectManagerPanel =
			new MetaObjectManagerPanel(title, c);
		panel.add(metaObjectManagerPanel, BorderLayout.CENTER);

		JPanel bottomPanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
		JButton close = new JButton("close");
		close.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				MetaObjectManagerDialog.this.setVisible(false);
			}
		});
		bottomPanel.add(close);
		panel.add(bottomPanel, BorderLayout.SOUTH);

		this.setContentPane(panel);
		this.pack();
		this.setResizable(true);

		int width = 800;
		int height = 400;

		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
		int x = (screen.width - width) / 2;
		int y = (screen.height - height) / 2;
		setBounds(x, y, width, height);
	}
}